<?php
class Smarty_Tmgco_Block_Redirect extends Mage_Core_Block_Template
{
    /**
     * Return checkout session instance
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }

    /**
     * Return order instance
     *
     * @return Mage_Sales_Model_Order|null
     */
    protected function _getOrder()
    {
        if ($this->getOrder()) {
            return $this->getOrder();
        } elseif ($orderIncrementId = $this->_getCheckout()->getLastRealOrderId()) {
            return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
        } else {
            return null;
        }
    }

    public function getFormHTMLContent ()
    {
      $params = $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
      $query_params = $params['params'];
      $form_url = $params['form'];
      $query = http_build_query ($query_params);
      $opts = array(
                'http' => array (
                        'method'=>'POST',
                        'header'=>'Content-type: application/x-www-form-urlencoded',
                        'content'=>$query
                  )
          );
      $context = stream_context_create($opts);
      return file_get_contents($form_url, false, $context);
    }

    /**
     * Get form data
     *
     * @return array
     */
    public function getFormData()
    {
        return $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
    }

    /**
     * Getting url of payment form
     *
     * @return string
     */
    public function getFormAction()
    {
        return $this->_getOrder()->getPayment()->getMethodInstance()->getUrl();
    }
}
